import { AmbientLight, DirectionalLight } from 'three';
import { EngineEvents } from '../types/events';
import { EngineComponent } from '../types/engine-component';
import { Renderer } from '../core/renderer';
import { EventEmitter } from '../utils/events';
import { Environment } from '../gameobjects/environment.object';
/**
 * This component manages game environment and world lighting.
 * @listens setEnvironment
 */
export declare class EnvironmentComponent extends EngineComponent {
    protected renderer: Renderer;
    protected events: EventEmitter<EngineEvents>;
    name: string;
    ambient: AmbientLight;
    directional: DirectionalLight;
    object: Environment;
    private cleanUpEvents?;
    constructor(renderer: Renderer, events: EventEmitter<EngineEvents>);
    initialize(): void;
    update(delta: number): void;
    dispose(): void;
    private bindEvents;
}
