import { EngineComponent } from '../types/engine-component';
import { Renderer } from '../core/renderer';
import { EngineEvents } from '../types/events';
import { EventEmitter } from '../utils/events';
/**
 * Manage mouse and object picking from screen.
 *
 * ViewportComponent and LevelComponent must be initialized before this component.
 */
export declare class MouseComponent extends EngineComponent {
    protected renderer: Renderer;
    protected events: EventEmitter<EngineEvents>;
    name: string;
    private world;
    private mouseButtons;
    private mouseButtonsLast;
    private mousePosition;
    private mousepositionNDC;
    private mousePositionLast;
    private mousepositionNDCLast;
    private canvasOffset;
    private cleanUpEvents?;
    private ray;
    constructor(renderer: Renderer, events: EventEmitter<EngineEvents>);
    get canvas(): HTMLCanvasElement;
    initialize(): void;
    update(delta: number): void;
    dispose(): void;
    private bindEvents;
}
