import { EventDispatcher, Object3D, Vector3 } from 'three';
/**
 * Freefly camera controls.
 * WASD + QE to move around.
 * Holding Right Mouse button rotates the view.
 * Holding Middle Mouse button pans the view.
 * Shift slows down movement.
 */
declare class CameraControls extends EventDispatcher {
    private camera;
    private domElement;
    private cameraMoving;
    private cameraPanning;
    minPolarAngle: number;
    maxPolarAngle: number;
    pointerSpeed: number;
    panSpeed: number;
    movementSpeed: number;
    shiftMultiplier: number;
    zoomScale: number;
    screenSpacePanning: boolean;
    private rotation;
    private look;
    private boundOnMouseMove;
    private boundOnMouseDown;
    private boundOnMouseUp;
    private boundOnKeyDown;
    private boundOnKeyUp;
    private boundOnScroll;
    private movement;
    constructor(camera: Object3D, domElement: HTMLElement);
    connect(): void;
    disconnect(): void;
    dispose(): void;
    update(dt: number): void;
    getDirection(v: Vector3): Vector3;
    moveForward(distance: number): void;
    moveUp(distance: number): void;
    moveRight(distance: number): void;
    private onMouseDown;
    private onMouseUp;
    private onScroll;
    private rotate;
    private pan;
    private onMouseMove;
    private onKeyDown;
    private onKeyUp;
}
export { CameraControls };
