import 'reflect-metadata';
import { Property } from '../types/property';
export function EditorProperty(editorPropertyDefinition) {
    return (target, propertyKey) => {
        let properties = Reflect.getOwnMetadata('properties', target);
        if (!properties) {
            Reflect.defineMetadata('properties', (properties = []), target);
        }
        properties.push(new Property({ ...editorPropertyDefinition, name: String(propertyKey) }));
    };
}
export function EditorPropertyExclude() {
    return (target, propertyKey) => {
        let excluded = Reflect.getOwnMetadata('excludedProperties', target);
        if (!excluded) {
            Reflect.defineMetadata('excludedProperties', (excluded = []), target);
        }
        excluded.push(String(propertyKey));
    };
}
