import { Color, Mesh, MeshPhongMaterial, } from 'three';
import { GameObject3D } from '../types/game-object';
import { Property } from '../types/property';
import { gameObjectFactory } from './factory';
export class Brick extends GameObject3D {
    constructor(geometry = gameObjectFactory.boxGeometry) {
        super();
        this.geometry = geometry;
        this.objectType = Brick.name;
        this.material = new MeshPhongMaterial();
        this.mesh = new Mesh(this.geometry, this.material);
        this.editorProperties.color = new Property('color', Color, true, []);
        this.editorProperties.transparency = new Property('transparency', Number, true, []);
        this.add(this.mesh);
    }
    get color() {
        return this.material.color;
    }
    set color(color) {
        this.material.color = new Color(color);
    }
    get transparency() {
        return 1 - this.material.opacity;
    }
    set transparency(value) {
        this.material.transparent = value != 0;
        this.material.opacity = 1 - value;
    }
}
