import { PhysicsObject } from './physics.object';
import { gameObjectGeometries } from './geometries';
import { Vector3 } from 'three';
export class Brick extends PhysicsObject {
    constructor(geometry = gameObjectGeometries.boxGeometry, material, mesh) {
        super(geometry, material, mesh);
        this.objectType = 'Brick';
        this.name = 'Brick';
    }
    createCollider(factory, world, body) {
        const scale = this.getWorldScale(new Vector3()).divideScalar(2);
        const collider = factory.ColliderDesc.cuboid(Math.abs(scale.x), Math.abs(scale.y), Math.abs(scale.z));
        return world.createCollider(collider, body);
    }
}
