import { Mesh, Vector3 } from 'three';
import { Brick } from './brick.object';
import { gameObjectGeometries } from './geometries';
export class Cylinder extends Brick {
    constructor() {
        super(gameObjectGeometries.cylinderGeometry);
        this.objectType = 'Cylinder';
        this.mesh = new Mesh(this.geometry, this.material);
        this.name = this.objectType;
    }
    createCollider(factory, world, body) {
        const scale = this.getWorldScale(new Vector3());
        const height = Math.abs(scale.y) / 2;
        const radius = (Math.abs(scale.x) / 2 + Math.abs(scale.z) / 2) / 2;
        const collider = factory.ColliderDesc.cylinder(height, radius);
        return world.createCollider(collider, body);
    }
}
