import { Color, Vector3 } from 'three';
import { EditorProperties, GameObject, SerializedObject } from '../types/game-object';
export declare const environmentEditorProperties: EditorProperties;
export declare class Environment extends GameObject {
    objectType: string;
    name: string;
    virtual: boolean;
    sunColor: Color;
    sunPosition: Vector3;
    sunStrength: number;
    ambientColor: Color;
    ambientStrength: number;
    clearColor: Color;
    constructor();
    serialize(): SerializedEnvironment;
}
export interface SerializedEnvironment extends SerializedObject {
    sunColor: Color;
    sunPosition: Vector3;
    sunStrength: number;
    ambientColor: Color;
    ambientStrength: number;
    clearColor: Color;
}
