import { Color, Vector3 } from 'three';
import { GameObject, } from '../types/game-object';
import { Property } from '../types/property';
import { environmentDefaults } from '../defaults/environment';
export const environmentEditorProperties = {
    sunColor: new Property('sunColor', Color, true, []),
    sunPosition: new Property('sunPosition', Vector3, true, []),
    sunStrength: new Property('sunStrength', Number, true, []),
    ambientColor: new Property('ambientColor', Color, true, []),
    ambientStrength: new Property('ambientStrength', Number, true, []),
    clearColor: new Property('clearColor', Color, true, []),
};
export class Environment extends GameObject {
    constructor() {
        super(environmentEditorProperties);
        this.objectType = Environment.name;
        this.name = Environment.name;
        this.virtual = true;
        this.sunColor = environmentDefaults.sunColor.clone();
        this.sunPosition = environmentDefaults.sunPosition.clone();
        this.sunStrength = environmentDefaults.sunStrength;
        this.ambientColor = environmentDefaults.ambientColor.clone();
        this.ambientStrength = environmentDefaults.ambientStrength;
        this.clearColor = environmentDefaults.clearColor.clone();
    }
    serialize() {
        return super.serialize();
    }
}
