var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Color, Vector3 } from 'three';
import { GameObject } from '../types/game-object';
import { environmentDefaults } from '../defaults/environment';
import { EditorProperty, EditorPropertyExclude } from '../decorators/property';
export class Environment extends GameObject {
    constructor() {
        super(...arguments);
        this.objectType = 'Environment';
        this.name = 'Environment';
        this.virtual = true;
        this.sunColor = environmentDefaults.sunColor.clone();
        this.sunPosition = environmentDefaults.sunPosition.clone();
        this.sunStrength = environmentDefaults.sunStrength;
        this.ambientColor = environmentDefaults.ambientColor.clone();
        this.ambientStrength = environmentDefaults.ambientStrength;
        this.clearColor = environmentDefaults.clearColor.clone();
    }
    serialize() {
        return super.serialize();
    }
}
__decorate([
    EditorPropertyExclude(),
    __metadata("design:type", Object)
], Environment.prototype, "name", void 0);
__decorate([
    EditorPropertyExclude(),
    __metadata("design:type", Boolean)
], Environment.prototype, "visible", void 0);
__decorate([
    EditorProperty({ type: Color }),
    __metadata("design:type", Object)
], Environment.prototype, "sunColor", void 0);
__decorate([
    EditorProperty({ type: Vector3 }),
    __metadata("design:type", Object)
], Environment.prototype, "sunPosition", void 0);
__decorate([
    EditorProperty({ type: Number }),
    __metadata("design:type", Object)
], Environment.prototype, "sunStrength", void 0);
__decorate([
    EditorProperty({ type: Color }),
    __metadata("design:type", Object)
], Environment.prototype, "ambientColor", void 0);
__decorate([
    EditorProperty({ type: Number }),
    __metadata("design:type", Object)
], Environment.prototype, "ambientStrength", void 0);
__decorate([
    EditorProperty({ type: Color }),
    __metadata("design:type", Object)
], Environment.prototype, "clearColor", void 0);
