import { Mesh, MeshPhongMaterial, Vector3, } from 'three';
import { Brick } from '.';
export class MeshPart extends Brick {
    constructor(geometry, material = new MeshPhongMaterial(), mesh = new Mesh(geometry, material)) {
        super(geometry, material, mesh);
        this.objectType = 'MeshPart';
    }
    /** Do some surgery to convert a loaded SkinnedMesh into a game object */
    static fromLoaded(loaded) {
        const newObject = new MeshPart(loaded.geometry, undefined, loaded);
        newObject.mesh.material = newObject.material;
        newObject.add(loaded);
        return newObject;
    }
    createCollider(factory, world, body) {
        const scale = this.getWorldScale(new Vector3()).divideScalar(2);
        const collider = factory.ColliderDesc.cuboid(Math.abs(scale.x), Math.abs(scale.y), Math.abs(scale.z));
        return world.createCollider(collider, body);
    }
}
