import { Sprite, SpriteMaterial } from 'three';
import { GameObject } from '../types/game-object';
export class NameTag extends GameObject {
    constructor() {
        super(...arguments);
        this.objectType = 'NameTag';
        this.virtual = true;
        this.archivable = false;
    }
    static create(builder, name) {
        const { texture, width, height } = builder.createTextCanvas(name, false, 48);
        const obj = new NameTag();
        obj.texture = texture;
        obj.width = width;
        obj.height = height;
        obj.material = new SpriteMaterial({
            map: texture,
            transparent: true,
        });
        const label = new Sprite(obj.material);
        const labelBaseScale = 0.01;
        label.scale.x = width * labelBaseScale;
        label.scale.y = height * labelBaseScale;
        obj.add(label);
        return obj;
    }
    dispose() {
        this.material.dispose();
        this.texture.dispose();
    }
}
