var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { GameObject3D } from '../types/game-object';
import { Color, Mesh, MeshPhongMaterial, } from 'three';
import { assetManager } from '../assets/manager';
import { AssetInfo } from '../types/asset';
import { EditorProperty } from '../decorators/property';
export class PhysicalObject extends GameObject3D {
    get color() {
        return this.material.color;
    }
    set color(color) {
        this.material.color = new Color(color);
    }
    get transparency() {
        return 1 - this.material.opacity;
    }
    set transparency(value) {
        this.material.transparent = value != 0;
        this.material.opacity = 1 - value;
        this.material.needsUpdate = true;
    }
    get texture() {
        return this.texturePath;
    }
    set texture(path) {
        if (!path) {
            this.material.map = null;
            this.texturePath = undefined;
            this.material.needsUpdate = true;
            return;
        }
        const asset = assetManager.getAssetByPath(path);
        if (!asset || !asset.texture) {
            console.error(`Asset ${path} does not exist or is not loaded`);
            return;
        }
        this.texturePath = path;
        this.material.map = asset.texture;
        this.material.needsUpdate = true;
    }
    constructor(geometry, material = new MeshPhongMaterial(), mesh = new Mesh(geometry, material)) {
        super();
        this.geometry = geometry;
        this.material = material;
        this.mesh = mesh;
        this.name = this.objectType;
        this.add(this.mesh);
    }
    getGeometry() {
        return this.geometry;
    }
    getMesh() {
        return this.mesh;
    }
}
__decorate([
    EditorProperty({ type: Color }),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], PhysicalObject.prototype, "color", null);
__decorate([
    EditorProperty({ type: Number }),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], PhysicalObject.prototype, "transparency", null);
__decorate([
    EditorProperty({ type: AssetInfo }),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], PhysicalObject.prototype, "texture", null);
