import { PhysicsTicking } from '../physics/ticking';
import type Rapier from '@dimforge/rapier3d';
import { PhysicalObject } from './physical.object';
export declare class PhysicsObject extends PhysicalObject implements PhysicsTicking {
    objectType: string;
    isTickingObject: boolean;
    protected collider?: Rapier.Collider;
    rigidBody?: Rapier.RigidBody;
    protected physicsWorldRef?: Rapier.World;
    canCollide: boolean;
    anchored: boolean;
    mass: number;
    friction: number;
    private _tempVec;
    private _tempQuat;
    private _tempQuat2;
    initialize(physicsEngine: typeof Rapier, physicsWorld: Rapier.World): void;
    tick(dt: number): void;
    dispose(): void;
    /**
     * Create collision shape for physics object.
     * @internal
     * @param factory Physics engine
     * @param world Physics world
     * @param body RigidBody
     */
    protected createCollider(factory: typeof Rapier, world: Rapier.World, body?: Rapier.RigidBody): Rapier.Collider | undefined;
}
