import { Mesh, Vector3 } from 'three';
import { Brick } from './brick.object';
import { gameObjectGeometries } from './geometries';
export class Sphere extends Brick {
    constructor() {
        super(gameObjectGeometries.sphereGeometry);
        this.objectType = 'Sphere';
        this.mesh = new Mesh(this.geometry, this.material);
        this.name = this.objectType;
    }
    createCollider(factory, world, body) {
        const scale = this.getWorldScale(new Vector3());
        const radius = Math.max(Math.abs(scale.x), Math.abs(scale.y), Math.abs(scale.z)) / 2;
        const collider = factory.ColliderDesc.ball(radius);
        return world.createCollider(collider, body);
    }
}
