import { Matrix4, Mesh, Vector3 } from 'three';
import { Brick } from './brick.object';
import { gameObjectGeometries } from './geometries';
export class Wedge extends Brick {
    constructor() {
        super(gameObjectGeometries.wedgeGeometry);
        this.objectType = 'Wedge';
        this.mesh = new Mesh(this.geometry, this.material);
        this.name = this.objectType;
    }
    createCollider(factory, world, body) {
        const scale = this.getWorldScale(new Vector3());
        const mat = new Matrix4();
        mat.makeScale(...scale.toArray());
        const points = this.getGeometry()
            .getAttribute('position')
            .clone()
            .applyMatrix4(mat)?.array;
        const collider = factory.ColliderDesc.convexMesh(points);
        return world.createCollider(collider, body);
    }
}
