import { Brick } from '../gameobjects';
import type RAPIER from '@dimforge/rapier3d';
import { PhysicsObject } from '../gameobjects/physics.object';
export declare class ColliderFactory {
    static gameObjectColliders: {
        instance: typeof Brick;
        createCollisionShape: (obj: PhysicsObject, factory: typeof RAPIER, world: RAPIER.World, body?: RAPIER.RigidBody) => RAPIER.Collider;
    }[];
    static createCollider<T extends PhysicsObject>(obj: T, factory: typeof RAPIER, world: RAPIER.World, body?: RAPIER.RigidBody): RAPIER.Collider | undefined;
}
