import { Quaternion, Vector3 } from 'three';
import { GameObject3D } from '../types/game-object';
import { Ticking } from '../types/ticking';
import type { Humanoid } from '../gameobjects/humanoid.object';
import type Rapier from '@dimforge/rapier3d';
export declare class PhysicsObjectAssociation implements Ticking {
    object: GameObject3D;
    collider?: Rapier.Collider | undefined;
    body?: Rapier.RigidBody | undefined;
    uuid: string;
    isTickingObject: boolean;
    constructor(object: GameObject3D, collider?: Rapier.Collider | undefined, body?: Rapier.RigidBody | undefined);
    initialize(): void;
    tick(dt: number): void;
}
export declare class HumanoidPhysicsProxy extends PhysicsObjectAssociation {
    private humanoid;
    private controller;
    constructor(humanoid: Humanoid, controller: Rapier.KinematicCharacterController, collider: Rapier.Collider, body: Rapier.RigidBody);
    applyMovement(position: Vector3, velocity: Vector3): void;
    applyRotation(quat: Quaternion): void;
}
