import { AnimationClip, Object3D, Texture } from 'three';
export type AssetType = 'Texture' | 'CubeTexture' | 'Mesh';
export interface Asset {
    name: string;
    path?: string;
    type: AssetType;
    texture?: Texture;
    object?: Object3D;
    animations?: AnimationClip[];
    data: any;
    remote?: boolean;
}
export declare class AssetInfo {
    path: string;
    name: string;
    constructor(path: string, name: string);
}
export type AssetsEvents = {
    load(asset: Asset | Asset[]): void;
    loadStart(asset: Asset): void;
    loadComplete(asset: Asset): void;
    loadError(asset: Asset, error?: Error): void;
};
