export class GameRunner {
    constructor() {
        /**
         * Last tick length in milliseconds.
         */
        this.lastTick = performance.now();
        /**
         * Game running flag.
         */
        this.running = false;
    }
    /**
     * Get delta time in seconds.
     * @param now Time since last frame in milliseconds
     */
    getDelta(now) {
        const delta = (now - this.lastTick) / 1000;
        this.lastTick = now;
        return delta;
    }
}
