export type EventMap = {
    [key: string]: (...args: any) => void;
};
export declare class EventEmitter<Events extends EventMap> {
    private _handlers;
    addListener<E extends keyof Events>(event: E, fn: Events[E], once?: boolean): void;
    on<E extends keyof Events>(event: E, fn: Events[E]): void;
    once<E extends keyof Events>(event: E, fn: Events[E]): void;
    emit<E extends keyof Events>(event: E, ...args: Parameters<Events[E]>): void;
    removeEventListener<E extends keyof Events>(event: E, fn: Events[E]): void;
    removeAllListeners<E extends keyof Events>(event: E): void;
}
