import { Cylinder } from './cylinder.object';
import { Brick } from './brick.object';
import { Sphere } from './sphere.object';
import { Wedge } from './wedge.object';
import { WedgeCorner } from './wedge-corner.object';
import { WedgeInnerCorner } from './wedge-inner-corner.object';
import { GameObject } from '../types/game-object';
import { Instancable } from '../types/instancable';
import { Group } from './group.object';
import { Torus } from './torus.object';
import { Capsule } from './capsule.object';
import { MeshPart } from './mesh.object';
import { Humanoid } from './humanoid.object';

export const instancableGameObjects: Record<string, Instancable<GameObject>> = {
  ['Group']: Group,
  ['Brick']: Brick,
  ['Cylinder']: Cylinder,
  ['Sphere']: Sphere,
  ['Torus']: Torus,
  ['Capsule']: Capsule,
  ['Wedge']: Wedge,
  ['WedgeCorner']: WedgeCorner,
  ['WedgeInnerCorner']: WedgeInnerCorner,
};

export * from './environment.object';
export * from './world.object';
export * from './nametag.object';
export * from './physical.object';
export * from './physics.object';
export {
  Group,
  Cylinder,
  Brick,
  Sphere,
  Torus,
  Capsule,
  Wedge,
  WedgeCorner,
  WedgeInnerCorner,
  MeshPart,
  Humanoid,
};
