import { EditorProperty } from '../decorators/property';
import { GameObject } from '../types/game-object';

export class World extends GameObject {
  public objectType = 'World';
  public name = 'World';
  public virtual = true;

  @EditorProperty({ type: Number })
  public gravity = -9.81;

  override get properties() {
    const properties = super.properties;
    return properties.filter((prop) => ['gravity'].includes(prop.name));
  }

  constructor() {
    super();
  }
}
