import type Rapier from '@dimforge/rapier3d';
import { Disposable } from '../types/disposable';

export interface PhysicsTicking extends Disposable {
  /**
   * @internal
   */
  isTickingObject: boolean;

  /**
   * @internal
   */
  uuid: string;

  /**
   * @internal
   */
  initialize(physicsEngine: typeof Rapier, physicsWorld: Rapier.World, controller?: Rapier.KinematicCharacterController): void;

  /**
   * @internal
   */
  tick(dt: number): void;
}
