import { Material, Object3D } from 'three';

export interface PropertyDefinition {
  name: string;
  type?: any;
  description?: string;
  exposed?: boolean;
  readonly?: boolean;
  validators?: Function[];
  postChange?(obj: Object3D | Material): void;
}

export class Property implements PropertyDefinition {
  public name!: string;
  public type?: any;
  public description?: string;
  public exposed?: boolean;
  public readonly?: boolean;
  public validators?: Function[];
  public postChange?(obj: Object3D | Material): void;

  constructor(definition: PropertyDefinition) {
    Object.assign(
      this,
      {
        exposed: true,
        validators: [],
      },
      definition
    );
  }
}
